SystemOrganization addCategory: #'Khami-Core'!
SystemOrganization addCategory: #'Khami-Core-Announcements'!
SystemOrganization addCategory: #'Khami-Core-Support'!

Object subclass: #KmGame
	instanceVariableNames: 'tilePool players board announcer currentTile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmGame class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/9/2011 18:40'!
testGame
	^self basicNew
		initializeWithTilePool: KmTile testSet;
		yourself! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 19:33'!
board
	^board! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 1/16/2011 20:19'!
currentTile
	^currentTile! !

!KmGame methodsFor: 'initialization' stamp: 'StuartHerring 1/16/2011 20:19'!
initializeWithTilePool: aPool
	self initialize.
	tilePool := aPool.
	board := KmGameBoard new.
	announcer := Announcer new.
	currentTile := nil.! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:24'!
placeTileAt: row at: column
	board at: row at: column put: currentTile.
	currentTile := nil.! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:26'!
remainingTiles
	^tilePool! !

!KmGame methodsFor: 'actions' stamp: 'StuartHerring 1/16/2011 20:20'!
takeTile
	^(currentTile := tilePool removeLast).! !

Object subclass: #KmGameBoard
	instanceVariableNames: 'board startingTile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:47'!
at: row at: column
	^board at: row at: column! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:20'!
at: row at: column put: aTile
	board at: row at: column put: aTile.
	(row = 1) ifTrue: [ board prependRow].
	(row = board rows) ifTrue: [board addRow].
	(column = 1) ifTrue: [ board prependColumn ].
	(column = board columns) ifTrue: [ board addColumn].! !

!KmGameBoard methodsFor: 'testing' stamp: 'StuartHerring 1/18/2011 19:17'!
canPlaceTile: aTile at: row at: column
	(board at: row at: column) ifNotNil: [^false].
	((board adjacentItemsAt: row at: column) noneSatisfy: [ :item | item notNil])
		ifTrue: [ ^false ].
	^KmLocation edges 
		allSatisfy: [ :side | self canPlaceTile: aTile toThe: side of: row and: column]
! !

!KmGameBoard methodsFor: 'testing' stamp: 'StuartHerring 1/18/2011 19:27'!
canPlaceTile: aTile toThe: aSide of: row and: column
	| r c |
	(aSide = Left) ifTrue: [ c := column - 1 ] 
		ifFalse: [ (aSide = Right) ifTrue: [ c := column + 1] ifFalse: [ c := column]].
	(aSide = Top) ifTrue: [ r := row - 1 ] 
		ifFalse: [ (aSide = Bottom) ifTrue: [ r := row + 1] ifFalse: [ r := row]].
	((r < 1) or: [c < 1]) ifTrue: [^true].
	((r > board rows) or: [c > board columns]) ifTrue: [^true].
	(board at: r at: c) ifNil: [^true].
	^(board at: r at: c) allowsTile: aTile at: aSide opposite! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:38'!
columns
	^board columns! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:49'!
initialize
	super initialize.
	startingTile := KmTile startingTile.
	board := KmGrid ofSize: 3 by: 3.
	board at: 2 at: 2 put: startingTile! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:38'!
rows
	^board rows! !

!KmGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:46'!
startingTile
	^startingTile! !

Object subclass: #KmGrid
	instanceVariableNames: 'rows cols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core-Support'!

!KmGrid class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 14:30'!
ofSize: rows by: columns
	^self new
		addColumns: columns;
		addRows: rows;
		yourself.! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:18'!
addColumn
	self addColumns: 1! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 14:28'!
addColumns: aNumber
	rows do:  [:row |
		aNumber timesRepeat: [ row add: nil ]].
	cols := cols + aNumber.
		! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:20'!
addRow
	self addRows: 1! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 14:07'!
addRows: aNumber
	aNumber timesRepeat:  [
		rows add: (OrderedCollection ofSize: cols)]! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2011 19:22'!
adjacentItemsAt: row at: column
	| return |
	return := OrderedCollection new.
	(row > 1) ifTrue: [ return add: (self at: row -1 at: column)].
	(column < cols) ifTrue: [ return add: (self at: row at: column + 1)].
	(row < rows size) ifTrue: [ return add: (self at: row  +1 at: column)].
	(column > 1) ifTrue: [ return add: (self at: row at: column - 1)].
	^return! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 09:44'!
at: row at: column
	^(rows at: row) at: column ! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 11:11'!
at: row at: column put: data
	(rows at: row) at: column put: data! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 11:59'!
columns
	^cols! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 12:12'!
initialize
	super initialize.
	rows := OrderedCollection new.
	cols := 0.! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:50'!
prependColumn
	rows do:  [:row |
		 row addFirst: nil ].
	cols := cols + 1.
		! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:48'!
prependRow
	rows addFirst: (OrderedCollection ofSize: cols)! !

!KmGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 11:59'!
rows
	^rows size! !

Object subclass: #KmLocation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmLocation subclass: #Bottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Bottom class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:02'!
clockwise
	^Left! !

!Bottom class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:18'!
opposite
	^Top! !

!Bottom class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:15'!
surroundingRegions
	^{BottomRight. BottomLeft}! !

KmLocation subclass: #BottomLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!BottomLeft class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:58'!
clockwise
	^LeftBottom! !

!BottomLeft class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:18'!
opposite
	^TopLeft! !

KmLocation subclass: #BottomRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!BottomRight class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:58'!
clockwise
	^BottomLeft! !

!BottomRight class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:19'!
opposite
	^TopRight! !

KmLocation subclass: #Centre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Centre class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:01'!
clockwise
	self shouldNotImplement! !

!Centre class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:21'!
opposite
	self shouldNotImplement! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:56'!
clockwise
	^self subclassResponsibility! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:22'!
edges
	^{Top. Right. Bottom. Left.}! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:17'!
opposite
	^self subclassResponsibility! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:22'!
pathLocations
	^{Top. Right. Bottom. Left. Centre}! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:30'!
regions
	^{TopLeft. TopRight. RightTop. RightBottom. 
		BottomRight. BottomLeft. LeftBottom. LeftTop}! !

!KmLocation class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:15'!
surroundingRegions
	^#()! !

KmLocation subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Left class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:01'!
clockwise
	^Top! !

!Left class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite 
	^Right! !

!Left class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:15'!
surroundingRegions
	^{LeftBottom. LeftTop}! !

KmLocation subclass: #LeftBottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!LeftBottom class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:58'!
clockwise
	^LeftTop! !

!LeftBottom class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:19'!
opposite
	^RightBottom! !

KmLocation subclass: #LeftTop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!LeftTop class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:59'!
clockwise
	^TopLeft! !

!LeftTop class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^RightTop! !

KmLocation subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Right class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:59'!
clockwise
	^Bottom! !

!Right class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite
	^Left! !

!Right class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:16'!
surroundingRegions
	^{RightTop. RightBottom}! !

KmLocation subclass: #RightBottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!RightBottom class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:00'!
clockwise
	^BottomRight! !

!RightBottom class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^LeftBottom! !

KmLocation subclass: #RightTop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!RightTop class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:00'!
clockwise
	^RightBottom! !

!RightTop class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^LeftTop! !

KmLocation subclass: #Top
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Top class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:00'!
clockwise
	^Right! !

!Top class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite
	^Bottom! !

!Top class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:16'!
surroundingRegions
	^{TopLeft. TopRight}! !

KmLocation subclass: #TopLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!TopLeft class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:01'!
clockwise
	^TopRight! !

!TopLeft class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^BottomLeft! !

KmLocation subclass: #TopRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!TopRight class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:01'!
clockwise
	^RightTop! !

!TopRight class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^BottomRight! !

Object subclass: #KmPiece
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmPiece class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/7/2011 15:07'!
forPlayer: aPlayer
	^self basicNew
		initializeWithPlayer: aPlayer;
		yourself! !

!KmPiece methodsFor: 'initialization' stamp: 'StuartHerring 1/7/2011 15:06'!
initializeWithPlayer: aPlayer
	self initialize.
	player := aPlayer! !

Object subclass: #KmPlayer
	instanceVariableNames: 'pieces colour name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

Object subclass: #KmTile
	instanceVariableNames: 'regions paths regionMap pathMap tiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmTile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 17:07'!
buildTileSet: aCollection
	^(aCollection collect: [ :string | self fromString: string ]) asOrderedCollection! !

!KmTile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/9/2011 10:10'!
fromString: aString
	^self new
		buildFromStream: (ReadStream on: aString);
		yourself! !

!KmTile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2011 09:39'!
startingTile
	^self fromString: 'VFFF.-.--'! !

!KmTile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/19/2011 01:04'!
testSet
	^self buildTileSet: {
		'VVFF.....'.
		'FFFF--..-'.
		'FFFF--..-'.
		'FFFF-....'.
		'FFFF.-.--'.
		'VFFF..---'.
		'FFFV.-...'.
		'VVVF.....'.
		'VVVV.....'.
		'VVVF.....'.
		'VFFF.-.--'.
		'VFFF.....'.
		'FFFF.....'.
		'VVVF...-.'.
		'VFFF.....'.
		'VVFF.....'.
		'VFVF.-.--'.
		'VFFF.--.-'.
		'FFFF.-.--'
	}! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 18:23'!
allowsTile: aTile at: aSide
	(self tileAt: aSide) ifNotNil: [ ^false].
	aSide surroundingRegions do: [ :r | ((self regionAt: r) connectsTo: (aTile regionAt: r opposite)) ifFalse: [ ^false] ].
	((self pathAt: aSide) connectsTo: (aTile pathAt: aSide opposite)) ifFalse: [ ^false ].
	^true! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 16:44'!
buildFromStream: aStream
	1 to: 4 do: [ :i | |char|
		char := aStream next.
		regions at: (i * 2 - 1) put: (KmRegion fromChar: char ).
		regions at: (i * 2) put: (KmRegion fromChar: char )].
	1 to: 5 do: [ :i | paths at: i put: (KmPath fromChar: aStream next)]! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/19/2011 00:35'!
initialize
	super initialize.
	tiles := Dictionary new.
	regions := (KmLocation regions collect: [ :x | KmFarmRegion new ]) asArray.
	paths :=  (KmLocation pathLocations collect: [ :x | KmTerminatorPath new ]) asArray.
	regionMap := Dictionary new.
	KmLocation regions
		keysAndValuesDo: [ :index :region | regionMap at: region put: index ].
	pathMap := Dictionary new.
	KmLocation pathLocations
		keysAndValuesDo: [ :index :symbol | pathMap at: symbol put: index ]! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:00'!
pathAt: aSymbol
	^paths at: (pathMap at: aSymbol)! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 17:58'!
regionAt: aSymbol
	^regions at: (regionMap at: aSymbol)! !

!KmTile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/19/2011 00:48'!
rotate
	regionMap keysAndValuesDo: [ :key : value | 
		regionMap at: key put: ((value + 5) \\ 8) + 1].
	pathMap keysAndValuesDo: [:key :value |
		(key = Centre) ifFalse: [pathMap at: key put: ((value + 2) \\ 4) + 1]]! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:10'!
tileAt: aDirection
	^tiles at: aDirection ifAbsent: [nil]! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 16:01'!
tileAt: aDirection put: aTile
	tiles at: aDirection ifAbsent: [
		tiles at: aDirection put: aTile.
		aTile tileAt: aDirection opposite put: self].
	^aTile! !

Object subclass: #KmTileSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmTileSegment subclass: #KmPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmPath class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:50'!
isAbstract 
	^self = KmPath! !

KmPath subclass: #KmRoadPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmRoadPath class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:59'!
codeCharacter
	^$-! !

!KmRoadPath methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 17:50'!
connectsTo: aSegment
	^aSegment isRoad! !

!KmRoadPath methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:58'!
isRoad
	^true! !

KmPath subclass: #KmTerminatorPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmTerminatorPath class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:59'!
codeCharacter
	^$.! !

!KmTerminatorPath methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 17:53'!
connectsTo: aSegment
	^aSegment isTerminator! !

!KmTerminatorPath methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 23:11'!
isTerminator
	^true! !

KmTileSegment subclass: #KmRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmRegion subclass: #KmFarmRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmFarmRegion class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:42'!
codeCharacter
	^$F! !

!KmFarmRegion methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 17:51'!
connectsTo: aSegment
	^aSegment isFarm! !

!KmFarmRegion methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 23:10'!
isFarm
	^true! !

!KmRegion class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:51'!
isAbstract
	^self = KmRegion! !

KmRegion subclass: #KmVillageRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmVillageRegion class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:42'!
codeCharacter
	^$V! !

!KmVillageRegion methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 17:51'!
connectsTo: aSegment
	^aSegment isVillage! !

!KmVillageRegion methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 23:11'!
isVillage
	^true! !

!KmTileSegment class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 22:49'!
codeCharacter
	self subclassResponsibility! !

!KmTileSegment class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/8/2011 23:10'!
fromChar: aChar
	^(self allSubclasses detect: [ :class | 
		(class isAbstract not) and: [class codeCharacter = aChar]]) new! !

!KmTileSegment methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:42'!
connectsTo: aSegment
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:59'!
isFarm 
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 17:15'!
isRoad
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:58'!
isTerminator 
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:59'!
isVillage 
	^false! !
